c
c     level  -- explanation
c     0      plot not called yet
c     1      a plot file is opened
c     2      limits for plotting set
c     3      a plot is ready, or finished

c
c----------------------------------------------------------------------
c
      SUBROUTINE GNinit(iarg)
#include "Implic.inc"
#include "gnuI.inc"
#include "tscunits.inc"

c     status: NEW        OLD    UNKNOWN     SCRATCH
c     access: SEQUENTIAL APPEND TRANSPARENT DIRECT
      INTEGER iarg
      INTEGER ifirst
      DATA    ifirst /
     ^        1      /

      CHARACTER*19 myfile
      CHARACTER*18 myout

      CHARACTER*8  zzdate
      CHARACTER*10 zztime
      CHARACTER*5  zzzone
c
c     zzdate  ccyymmdd    cc=century yy=year mm=month dd=day
c     zztime  hhmmss.ttt  hh=hour mm=minute ss=second ttt=millisecond
c     zzzone  Shhmm       S=sign (-=west, +=east) hh=hour mm=minute
c
      INTEGER ivals(8)
c                             EXAMPLE
c     ivals ( 1 ) year        "2000"   
c     ivals ( 2 ) month       "10"
c     ivals ( 3 ) day         "12"
c     ivals ( 4 ) t - UTC     "-0400"
c     ivals ( 5 ) hour        "8"
c     ivals ( 6 ) minute      "21"
c     ivals ( 7 ) second      "23"
c     ivals ( 8 ) millisecond "621"
c

      if (ifirst .eq. 1) then
          level = 0
          ifirst = 0
      endif
      iUnit = iarg


      if (level .eq. 0)      then
         call date_and_time(zzdate,zztime,zzzone,ivals)
         write(myfile,'(a)') zzdate(3:4)/ /'-'/ /zzdate(5:6)/ /'-'/ /
     ^                       zzdate(7:8)/ /'-'/ /zztime(1:6)/ /
     ^                       '.gnp'

         write(myout ,'(a)') zzdate(3:4)/ /'-'/ /zzdate(5:6)/ /'-'/ /
     ^                       zzdate(7:8)/ /'-'/ /zztime(1:6)/ /
     ^                       '.ps'
c
c        myfile
c        yy-mm-dd-hhmmss.gnp
c        123456789 123456789
c
c        myout
c        yy-mm-dd-hhmmss.ps
c        123456789 12345678
c
         open (iUnit, status='unknown',
     ^                file = myfile,
     ^                err=1300 )
         write (iUnit,'(a)') 'set terminal postscript'
         write (iUnit,'(a)') 'set output "'/ /myout/ /'"'
         write (iUnit,'(a)') 'set nokey'
         write (iUnit,'(a)') '# terminal opened by GNinit'
         level = 1
      else if (level .eq. 1) then 
         write (iUnit,'(a)') 'set multiplot # by GNinit'
         write (iUnit,'(a)') 'set nolabel   # by GNinit'
         level = 2
      else if (level .eq. 2) then 
         level = 3
      else 
         level = 3
      endif

      return
 1300 write(nTSCscrn,'('' cannot open GNUplot file: '', a )') myfile
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNfini
#include "Implic.inc"
#include "gnuI.inc"
      if ( level .ge. 2 ) then
           write (iUnit,'(a)') 'set nomultiplot # by GNfini '
           write (iUnit,'(a)') 'set title       # by GNfini '
           level=1
      else
           write (iUnit,'(a)') '# end of file #'
           close (iUnit)
           level=0
      endif

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNfinL
#include "Implic.inc"
#include "gnuI.inc"
      if ( level .ge. 2 ) then
           write (iUnit,'(a)') '# empty graph trick, start #'
           write (iUnit, 600)
 600       format('set origin 0.80,0.0',/,'set size    0.15, 0.15',/,
     ^       'set xrange [-1:1]',/,      'set yrange [ 0.:1]',/,
     ^       'set nozeroaxis',/,         'set noborder',/,
     ^       'set noxtics',/,            'set noytics',/,
     ^       'plot ''-'' with impulses',/,
     ^       '  0 0',/,
     ^       'e',/,
     ^       'set nomultiplot',/,
     ^       'reset')
         write (iUnit,'(a)') 'set nokey'
         write (iUnit,'(a)') 'set title'
           write (iUnit,'(a)') '# empty graph trick, stop #'
           level=1
      else
           write (iUnit,'(a)') '# end of file #'
           close (iUnit)
           level=0
      endif

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNsets(i,j,k,l,a,b,c,d,kind)
#include "Implic.inc"
#include "gnuI.inc"
#include "gnuR.inc"
      INTEGER i,j,k,l,kind
      REAL    a,b,c,d
      real    xorigin, yorigin
      real    xsize  , ysize
      xorigin =  real(i)  /1024.
      yorigin =  real(k)  / 768.
      xsize   =  real(j-i)/1024.
      ysize   =  real(l-k)/ 768.
      if (level .eq. 1) then
         write (iUnit,'(a)') 'set multiplot # by GNsets'
         write (iUnit,'(a)') 'set nolabel   # by GNsets'
         level = 2
      endif

      write(iUnit,'(''set origin '' , f5.2,'','', f5.2)') 
     ^                                             xorigin, yorigin

      if (j-i .eq. l-k) then
      write(iUnit,'(''se si sq ''   , f5.2,'','', f5.2)') 
     ^                                               xsize,   ysize
      else
      write(iUnit,'(''se si nosq '' , f5.2,'','', f5.2)') 
     ^                                               xsize,   ysize
      endif

      write(iUnit,'(''se xr ['',1pe9.2,'':'',1pe9.2,'']'')') 
     ^                                                            a,b

      write(iUnit,'(''se yr ['',1pe9.2,'':'',1pe9.2,'']'')') 
     ^                                                            c,d
      level=3
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNdra ( x, y, i )
#include "Implic.inc"
#include "gnuI.inc"
#include "gnuR.inc"
      INTEGER i
      REAL    x, y
      INTEGER ixplot, iyplot
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNcros ( xs, ys, n )
#include "Implic.inc"
#include "gnuI.inc"
#include "gnuR.inc"
      INTEGER i, n
      REAL    xs(n), ys(n), x, y
      INTEGER ixplot, iyplot, size
      DATA    size / 1 /

      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with points"
      do i = 1, n
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) xs(i), ys(i)
      enddo
      write (iUnit,'(a)') 'e'
c
      return
      END
c
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNbars(x,y,n,ch)
#include "Implic.inc"
#include "gnuI.inc"
      CHARACTER*1 ch
      INTEGER i, n
      REAL    x(n), y(n), zero
      DATA    zero / CONST(0.0,0) /

      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with impulses"
      i = 1
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      do i = 2, n-1
         if ( y(i) .ne. zero ) then
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      i = n
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNcurv(x,y,n)
#include "Implic.inc"
#include "gnuI.inc"
      INTEGER i, n
      REAL    x(n), y(n), zero 
      DATA    zero / CONST(0.0,0) /
      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with lines"
      i = 1
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      do i = 2, n-1
         if ( y(i)   .ne. zero .or.      
     ^        y(i-1) .ne. zero .or. 
     ^        y(i+1) .ne. zero       ) then
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      i = n
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNcurD(x,y,n)
#include "Implic.inc"
#include "gnuI.inc"
      INTEGER i, n
      REAL    x(n), y(n)

      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with lines"
      i = 1
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      do i = 2, n-1
         if (y(i) .ne. y(i-1) .or.
     ^       y(i) .ne. y(i+1)      ) then
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      i = n
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNpnts(x,y,n)
#include "Implic.inc"
#include "gnuI.inc"
      INTEGER i, n, iskip
      REAL    x(n), y(n)

      call GNzero(x,y,n)

      iskip = (n+40)/100
      if (iskip .eq. 0) iskip=1

      write (iUnit,'(a)') "plot '-' with dots"

      do i = 1, n, iskip
         if (y(i) .eq. 0.0) then
         write( iUnit, '(1x, 1pe9.2, 1x, ''0'' )' ) x(i)
         else
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNpnt2(x,y,n)
#include "Implic.inc"
#include "gnuI.inc"
      INTEGER i, n
      REAL    x(n), y(n)

      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with dots"
      do i = 1, n, 2
         if (y(i) .eq. 0.0) then
         write( iUnit, '(1x, 1pe9.2, 1x, ''0'' )' ) x(i)
         else
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNpntD(x,y,n)
#include "Implic.inc"
#include "gnuI.inc"
      INTEGER i, n
      REAL    x(n), y(n)

      call GNzero(x,y,n)

      write (iUnit,'(a)') "plot '-' with dots"
      i = 1
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      do i = 2, n-1
         if (y(i) .ne. y(i-1) .or.
     ^       y(i) .ne. y(i+1)      ) then
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)
         endif
      enddo

      i = n
         write( iUnit, '(1x, 1pe9.2, 1x, 1pe9.2)' ) x(i), y(i)

      write (iUnit,'(a)') 'e'

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNzero(x,y,n)
#include "Implic.inc"
      INTEGER i, n
      REAL    x(n), y(n)
      REAL       SMALL   ,       zero
      DATA       SMALL   ,       zero   / 
     ^     CONST(1.0,-30), CONST(0.0,0) /

      do i = 1, n
         if ( abs (y(i)) .lt. SMALL) y(i) = zero
      enddo

      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNtitl(Title)
#include "Implic.inc"
#include "gnuI.inc"
      CHARACTER*(*) Title
      CHARACTER*24  MyTitle
      INTEGER         l
      l = INDEX(Title,'$')
      if (l .gt. 1) then
         l = l-1
         write(MyTitle,'(a)') Title(1:l)
      else
         MyTitle = Title
      endif
      write (iUnit,'(''se tit "'', a, ''"'')') MyTitle
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNwrit(i,j,string,lcen,lor)
#include "Implic.inc"
#include "gnuI.inc"
#include "gnuR.inc"
c                                 ,lcen,lor  ignored
c      xsize   = float(j-i)/1024.
c      ysize   = float(l-k)/ 768.

      CHARACTER string*(*)
      CHARACTER*1 dollar
      INTEGER     i,j,lcen,lor, indx, MAX, n
      real        xplace, yplace
      DATA        dollar,   MAX/
     ^            '$'   ,   75 /
      
      xplace =  real(i)/1024.
      yplace =  real(j)/ 768.

      n=0
      do 10 indx=1,MAX
        if(string(indx:indx) .eq. dollar) go to 30
        n=n+1
10    continue
 
30    continue
      if(n.eq.0) return
 
100   continue

      write(iUnit,600) string(1:n), xplace, yplace
 600  format('se la "',a,'" at screen ',f6.3,',',f6.3)
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE GNlist(i,j,string,lcen,lor)
#include "Implic.inc"
#include "gnuI.inc"
#include "gnuR.inc"
c                                 ,lcen,lor) ignored
c      xsize   = float(j-i)/1024.
c      ysize   = float(l-k)/ 768.

      CHARACTER string*(*)
      CHARACTER*1 dollar
      INTEGER     i,j,lcen,lor, indx, MAX, n
      real        xplace, yplace
      DATA        dollar,   MAX/
     ^            '$'   ,   75 /
      
      xplace =  real(i)/1024.
      yplace =  real(j)/ 768.

      n=0
      do 10 indx=1,MAX
        if(string(indx:indx) .eq. dollar) go to 30
        n=n+1
10    continue
 
30    continue
      if(n.eq.0) return
 
100   continue

      write(iUnit,600) string(1:n), xplace, yplace
 600  format('se la "',a,'" at screen ',f6.3,',',f6.3,'font "Courier"')
      return
      END
c
c----------------------------------------------------------------------
c
